<?
// This file contains functions used by the admin interface 

function display_category_form($category = "")
// This displays the category form.
// This form can be used for inserting or editing categories.
// To insert, don't pass any parameters.  This will set $edit
// to false, and the form will go to insert_category.php.
// To update, pass an array containing a category.  The
// form will contain the old data and point to update_category.php.
// It will also add a "Delete category" button.
{
  // if passed an existing category, proceed in "edit mode"
  $edit = is_array($category);

  // most of the form is in plain HTML with some
  // optional PHP bits throughout
?>
  <form method=post 
      action="<?=$edit?"edit_category.php":"insert_category.php";?>"> 
  <table border=0>
  <tr>
    <td>Category Name:</td>
    <td><input type=text name=category size=40 maxlength=40
          value="<?=$edit?$category["category"]:""; ?>"></td>
   </tr>
  <tr>
    <td <? if (!$edit) echo "colspan=2"; ?> align=center>
      <? if ($edit) 
         echo "<input type=hidden name=catid 
                value=\"".$category["catid"]."\">";
      ?>
      <input type=submit 
       value="<?=$edit?"Update":"Add"; ?> Category"></form>
     </td>
     <? if ($edit)
       // allow deletion of existing categories 
       {
          echo "<td>";
          echo "<form method=post action=\"delete_category.php\">";
          echo "<input type=hidden name=catid value=\"".$category[catid]."\">";
          echo "<input type=submit value=\"Delete category\">";
          echo "</form></td>";
       }
     ?>
  </tr>
  </table>
<?
}

function display_book_form($book = "")
// This displays the book form.
// It is very similar to the category form.
// This form can be used for inserting or editing books.
// To insert, don't pass any parameters.  This will set $edit
// to false, and the form will go to insert_book.php.
// To update, pass an array containing a book.  The
// form will be displayed with the old data and point to update_book.php.
// It will also add a "Delete book" button.
{
  
  // if passed an existing book, proceed in "edit mode"
  $edit = is_array($book);

  // most of the form is in plain HTML with some
  // optional PHP bits throughout
?>
  <form method=post
        action="<?=$edit?"edit_book.php":"insert_book.php";?>">
  <table border=0>
  <tr>
    <td>Dept abbrev:</td>
    <td><input type=text name=digraph size=5
         value="<?=$edit?$book["digraph"]:""; ?>"></td>
  </tr>
  <tr>
    <td>Course number:</td>
    <td><input type=text name=crsenr size=5
         value="<?=$edit?$book["crsenr"]:""; ?>"></td>
  </tr>
  <tr>
    <td>Course title:</td>
    <td><input type=text name=title size=80
         value="<?=$edit?$book["title"]:""; ?>"></td>
   </tr>
   <tr>
      <td>Category:</td>
      <td><select name=catid>
      <?
          // list of possible categories comes from database
          $cat_array=get_categories();
          foreach ($cat_array as $thiscat)
          {
               echo "<option value=\"";
               echo $thiscat["catid"];
               echo "\"";
               // if existing course, put in current category
               if ($edit && $thiscat["catid"] == $book["catid"])
                   echo " selected";
               echo ">"; 
               echo $thiscat["category"];
               echo "\n"; 
          }
          ?>
          </select>
        </td>
   </tr>
   <tr>
    <td>Regularly offered:</td>
    <td><input type=text name=regOffered size=30
               value="<?=$edit?$book["regOffered"]:""; ?>"></td>
   </tr>
      <tr>
    <td>Department name:</td>
    <td><input type=text name=department size=30
               value="<?=$edit?$book["department"]:""; ?>"></td>
   </tr>
      <tr>
    <td>Level:</td>
    <td><input type=text name=level size=30
               value="<?=$edit?$book["level"]:""; ?>"></td>
   </tr>
      <tr>
    <td>Target audience:</td>
    <td><input type=text name=targetAudience size=60
               value="<?=$edit?$book["targetAudience"]:""; ?>"></td>
   </tr>
   <tr>
     <td>Description:</td>
     <td><textarea rows=5 cols=60 
          name=description>
          <?=$edit?$book["description"]:""; ?>
          </textarea></td>
    </tr>
    <tr>
    <td>Key concepts:</td>
    <td><input type=text name=keyConcepts size=80
               value="<?=$edit?$book["keyConcepts"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Course URL:</td>
    <td><input type=text name=url size=50
               value="<?=$edit?$book["url"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Next offered:</td>
    <td><input type=text name=nextOffered size=50
               value="<?=$edit?$book["nextOffered"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Instructor:</td>
    <td><input type=text name=instructor size=50
               value="<?=$edit?$book["instructor"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Package used:</td>
    <td><input type=text name=package size=50
               value="<?=$edit?$book["package"]:""; ?>"></td>
   </tr>

    <tr>
      <td <? if (!$edit) echo "colspan=2"; ?> align=center>
         <? 
            if ($edit)
            {
             // we need the old isbn to find book in database
             // if the isbn is being updated
			   $newcode=$book["digraph"].$book["crsenr"];
			 //  echo "newcode is $newcode<br>"; 
               echo "<input type=hidden name=newcode value=\"".$newcode."\">";           
            }
         ?>
        <input type=submit
               value="<?=$edit?"Update":"Add"; ?> course">
        </form></td>
        <? 
           if ($edit)
           {  
             echo "<td>";
             echo "<form method=post action=\"delete_book.php\">";
             echo "<input type=hidden name=newcode 
                    value=\"".$book["digraph"].$book["crsenr"]."\">";
             echo "<input type=submit 
                    value=\"Delete course\">";
             echo "</form></td>";
            }
          ?>
         </td>
      </tr>
  </table>
  </form>
<?
}

function display_password_form()
{
// displays html change password form
?>
   <br>
   <form action="change_password.php" method=post>
   <table width=250 cellpadding=2 cellspacing=0 bgcolor=#cccccc>
   <tr><td>Old password:</td>
       <td><input type=password name=old_passwd size=16 maxlength=16></td>
   </tr>
   <tr><td>New password:</td>
       <td><input type=password name=new_passwd size=16 maxlength=16></td>
   </tr>
   <tr><td>Repeat new password:</td>
       <td><input type=password name=new_passwd2 size=16 maxlength=16></td>
   </tr>
   <tr><td colspan=2 align=center><input type=submit value="Change password">
   </td></tr>
   </table>
   <br>
<?
};

function insert_category($category)
// inserts a new category into the database
{
   $conn = db_connect();

   // check category does not already exist
   $query = "select *
             from RMcats
             where category='$category'";
   $result = mysql_query($query);
   if (!$result || mysql_num_rows($result)!=0)
     return false;  

   // insert new category 
   $query = "insert into RMcats values
            ('', '$category')"; 
   $result = mysql_query($query);
   if (!$result)
     return false;
   else
     return true;
}

function insert_book($digraph, $crsenr, $title, $catid, $regOffered, $department, $level, $targetAudience, $description, $keyConcepts, $url, $dateMod, $nextOffered, $instructor, $package)
// insert a new course into the database 
{
   $conn = db_connect();

   // check course does not already exist
   $digraph = strtoupper($digraph);
   $title = ucwords($title);
   $regOffered = ucwords($regOffered);
   $department = ucwords($department);
   $targetAudience = ucwords($targetAudience);
   // $package = ucwords($package);
   $instructor = ucwords($instructor);
   $query = "select *
             from RMcourses 
             where digraph='$digraph' and crsenr='$crsenr'";
   $result = mysql_query($query);
   if (!$result || mysql_num_rows($result)!=0)
     return false;
   // insert new course:
   // must also deal with RMinsts
   $dateMod = date("Y-m-d");
   $query = "insert into RMcourses values
            ('$digraph', '$crsenr', '$title', '$catid', '$regOffered', '$department', '$level', '$targetAudience', '$description', '$keyConcepts', '$url', '$dateMod')";
// echo "$query<br>\n";
   $result = mysql_query($query);
   if (!$result)
     return false;
   else
      $query = "insert into RMinsts values
            ('$digraph', '$crsenr', '$nextOffered', '$instructor', '$package', '$url', '$dateMod')";
   			$result = mysql_query($query);
   			if (!$result)
     			return false;
			else
     			return true;
}

function update_category($catid, $category)
// change the name of category with catid in the database
{
   $conn = db_connect();

   $query = "update RMcats
             set category='$category'
             where catid='$catid'";
   $result = @mysql_query($query);
   if (!$result)
     return false;
   else
     return true; 
}

function update_book($newcode, $digraph, $crsenr, $title, $catid, $regOffered, $department, $level, $targetAudience, 
$description, $keyConcepts, $url, $dateMod, $nextOffered, $instructor, $package)

// change details of course stored under $oldcode in
// the database to new details in arguments
{
   $conn = db_connect();
//   $dateArray = getdate();
   $dateMod = date("Y-m-d");
// echo "newcode is $newcode<br>"; 
   $olddg = substr($newcode,0,2);
   $oldcn = substr($newcode,2,3);
   $digraph = strtoupper($digraph);
   $title = ucwords($title);
   $regOffered = ucwords($regOffered);
   $department = ucwords($department);
   $targetAudience = ucwords($targetAudience);
   $instructor = ucwords($instructor);
   // $package = ucwords($package);
//   echo "newcode is $olddg | $oldcn<br>";
   $query = "update RMcourses
             set digraph='$digraph',
             crsenr='$crsenr',
             title ='$title',
             catid = '$catid',
             regOffered = '$regOffered',
             department = '$department',
             level = '$level',
             targetAudience = '$targetAudience',
             description = '$description',
             keyConcepts = '$keyConcepts',
             url = '$url',
             dateMod = '$dateMod'
             where digraph='$olddg' and crsenr='$oldcn'";
// echo "$query<br>\n";

   $result = @mysql_query($query);
   if (!$result)
     return false;
   else
   		$query = "update RMinsts 
   		          set digraph='$digraph',
            	  crsenr='$crsenr', 
            	  nextOffered='$nextOffered',
            	  instructor='$instructor',
            	  package='$package',
            	  dateMod = '$dateMod'
            	  where digraph='$olddg' and crsenr='$oldcn'";
// echo "$query<br>\n";
        $result = @mysql_query($query); 
        if (!$result)
                  return false;
        else  
     			  return true; 
}

function delete_category($catid)
// Remove the category identified by catid from the db
// If there are courses in the category, it will not
// be removed and the function will return false.
{
   $conn = db_connect();
   
   // check if there are any courses in category 
   // to avoid deletion anomalies   
   $query = "select *
             from RMcourses
             where catid='$catid'";
   $result = @mysql_query($query);
   if (!$result || @mysql_num_rows($result)>0)
     return false;

   $query = "delete from RMcats 
             where catid='$catid'";
   $result = @mysql_query($query);
   if (!$result)
     return false;
   else
     return true; 
}


function delete_book($digraph, $crsenr)
// Deletes the book identified by $isbn from the database.
{
   $conn = db_connect();

   $query = "delete from RMcourses
             where digraph='$digraph' and crsenr='$crsenr'";
   $result = @mysql_query($query);
   if (!$result)
     return false;
   else
      $query = "delete from RMinsts
             where digraph='$digraph' and crsenr='$crsenr'";
                if (!$result)
     				return false;
   				else
   					return true;
}

?>
